Catalog API (2.0.0)
- Version: 2.0.0
- Servers:
https://store.xsolla.com/api - Contact Us by Email
- Contact URL: https://xsolla.com/
- Required TLS version: 1.2
The Catalog API allows you to configure a catalog of in-game items on the Xsolla side and display the catalog to users in your store.
The API allows you to manage the following catalog entities:
- Virtual items — in-game items such as weapons, skins, boosters.
- Virtual currency — virtual money used to purchase virtual goods.
- Virtual currency packages — predefined bundles of virtual currency.
- Bundles — combined packages of virtual items, currency, or game keys sold as a single SKU.
- Game keys — keys for games and DLCs distributed via platforms like Steam or other DRM providers.
- Groups — logical groupings for organizing and sorting items within the catalog.
The API is divided into the following groups:
Admin — calls for creating, updating, deleting, and configuring catalog items and groups. Authenticated via basic access authentication with your merchant or project credentials. Not intended for storefront use.Catalog — calls for retrieving items and building custom storefronts for end users. Designed to handle high-load scenarios. Support optional user JWT authorization to return personalized data such as user-specific limits and active promotions.
API calls require authentication either on behalf of a user or on behalf of a project. The authentication scheme used is specified in the Security section in the description of each call.
User's JWT authentication is used when a request is sent from a browser, mobile application, or game. By default, the XsollaLoginUserJWT scheme is applied. For details on how to create a token, see the Xsolla Login API documentation.
The token is passed in the Authorization header in the following format: Authorization: Bearer <user_JWT>, where <user_JWT> is the user token. The token identifies the user and provides access to personalized data. You can try this call using the following test token:
eyJ0eXAiOiJKV1QiLCJhbGciOiJIUzI1NiJ9.eyJleHAiOjE5NjIyMzQwNDgsImlzcyI6Imh0dHBzOi8vbG9naW4ueHNvbGxhLmNvbSIsImlhdCI6MTU2MjE0NzY0OCwidXNlcm5hbWUiOiJ4c29sbGEiLCJ4c29sbGFfbG9naW5fYWNjZXNzX2tleSI6IjA2SWF2ZHpDeEVHbm5aMTlpLUc5TmMxVWFfTWFZOXhTR3ZEVEY4OFE3RnMiLCJzdWIiOiJkMzQyZGFkMi05ZDU5LTExZTktYTM4NC00MjAxMGFhODAwM2YiLCJlbWFpbCI6InN1cHBvcnRAeHNvbGxhLmNvbSIsInR5cGUiOiJ4c29sbGFfbG9naW4iLCJ4c29sbGFfbG9naW5fcHJvamVjdF9pZCI6ImU2ZGZhYWM2LTc4YTgtMTFlOS05MjQ0LTQyMDEwYWE4MDAwNCIsInB1Ymxpc2hlcl9pZCI6MTU5MjR9.GCrW42OguZbLZTaoixCZgAeNLGH2xCeJHxl8u8Xn2aIAlternatively, you can use a token for opening the payment UI.
Basic HTTP authentication is used for server-to-server interactions, when an API call is sent directly from your server rather than from a user's browser or mobile application. HTTP Basic authentication with an API key is typically used.
The API key is confidential and must not be stored or used in client applications.
With basic server-side authentication, all API requests must include the following header:
- for
basicAuth—Authorization: Basic <your_authorization_basic_key>, whereyour_authorization_basic_keyis theproject_id:api_keypair encoded in Base64 - for
basicMerchantAuth—Authorization: Basic <your_authorization_basic_key>, whereyour_authorization_basic_keyis themerchant_id:api_keypair encoded in Base64
You can find the parameter values in Publisher Account:
merchant_idis displayed:- In Company settings > Company.
- In the URL in the browser address bar on any Publisher Account page. The URL has the following format:
https://publisher.xsolla.com/<merchant_id>.
project_idis displayed:- Next to the project name in Publisher Account.
- In the URL in the browser address bar when working on a project in Publisher Account. The URL has the following format:
https://publisher.xsolla.com/<merchant_id>/projects/<project_id>.
api_keyis shown in Publisher Account only at the time of creation and must be stored securely on your side. You can create an API key in the following sections:
If a required API call doesn't include the
project_id path parameter, use an API key that is valid across all company projects for authorization.For more information about working with API keys, see the API references.
The AuthForCart authentication scheme is used for cart purchases and supports two modes:
- Authentication with a user's JWT. The token is passed in the
Authorizationheader in the following format:Authorization: Bearer <user_JWT>, where<user_JWT>is the user token. The token identifies the user and provides access to personalized data. You can try this call using the following test token:
eyJ0eXAiOiJKV1QiLCJhbGciOiJIUzI1NiJ9.eyJleHAiOjE5NjIyMzQwNDgsImlzcyI6Imh0dHBzOi8vbG9naW4ueHNvbGxhLmNvbSIsImlhdCI6MTU2MjE0NzY0OCwidXNlcm5hbWUiOiJ4c29sbGEiLCJ4c29sbGFfbG9naW5fYWNjZXNzX2tleSI6IjA2SWF2ZHpDeEVHbm5aMTlpLUc5TmMxVWFfTWFZOXhTR3ZEVEY4OFE3RnMiLCJzdWIiOiJkMzQyZGFkMi05ZDU5LTExZTktYTM4NC00MjAxMGFhODAwM2YiLCJlbWFpbCI6InN1cHBvcnRAeHNvbGxhLmNvbSIsInR5cGUiOiJ4c29sbGFfbG9naW4iLCJ4c29sbGFfbG9naW5fcHJvamVjdF9pZCI6ImU2ZGZhYWM2LTc4YTgtMTFlOS05MjQ0LTQyMDEwYWE4MDAwNCIsInB1Ymxpc2hlcl9pZCI6MTU5MjR9.GCrW42OguZbLZTaoixCZgAeNLGH2xCeJHxl8u8Xn2aIAlternatively, you can use a token for opening the payment UI.
- Simplified mode without Authorization header. This mode is used only for unauthorized users and can be applied only for game key sales. Instead of a token, the request must include the following headers:
x-unauthorized-idwith a request IDx-userwith the user's email address encoded in Base64
Items of all types (virtual items, bundles, virtual currency, and keys) use a similar data structure. Understanding the basic structure simplifies working with the API and helps you navigate the documentation more easily.
Some calls may include additional fields but they don't change the basic structure.
Identification
merchant_id— company ID in Publisher Accountproject_id— project ID in Publisher Accountsku— item SKU, unique within the project
Store display
name— item namedescription— item descriptionimage_url— image URLis_enabled— item availabilityis_show_in_store— whether the item is displayed in the catalog
For more information about managing item availability in the catalog, see the documentation.
Organization
type— item type, for example, a virtual item (virtual_item) or bundle (bundle)groups— groups the item belongs toorder— display order in the catalog
Sale conditions
prices— prices in real or virtual currencylimits— purchase limitsperiods— availability periodsregions— regional restrictions
Example of core entity structure:
{
"attributes": [],
"bundle_type": "virtual_currency_package",
"content": [
{
"description": {
"en": "Main in-game currency"
},
"image_url": "https://.../image.png",
"name": {
"en": "Crystals",
"de": "Kristalle"
},
"quantity": 500,
"sku": "com.xsolla.crystal_2",
"type": "virtual_currency"
}
],
"description": {
"en": "Crystals x500"
},
"groups": [],
"image_url": "https://.../image.png",
"is_enabled": true,
"is_free": false,
"is_show_in_store": true,
"limits": {
"per_item": null,
"per_user": null,
"recurrent_schedule": null
},
"long_description": null,
"media_list": [],
"name": {
"en": "Medium crystal pack"
},
"order": 1,
"periods": [
{
"date_from": null,
"date_until": "2020-08-11T20:00:00+03:00"
}
],
"prices": [
{
"amount": 20,
"country_iso": "US",
"currency": "USD",
"is_default": true,
"is_enabled": true
}
],
"regions": [],
"sku": "com.xsolla.crystal_pack_2",
"type": "bundle",
"vc_prices": []
}The Xsolla API allows you to implement in-game store logic, including retrieving the item catalog, managing the cart, creating orders, and tracking their status. Depending on the integration scenario, API calls are divided into Admin and Catalog subsections, which use different authentication schemes.
The following example shows a basic flow for setting up and operating a store, from item creation to purchase.
Create an item catalog for your store, such as virtual items, bundles, or virtual currency.
Example API calls:
Configure user acquisition and monetization tools, such as discounts, bonuses, daily rewards, or offer chains.
Example API calls:
Configure item display in your application.
Do not use API calls from the Admin subsection to build a user catalog. These API calls have rate limits and aren't intended for user traffic.
Example API calls:
By default, catalog API calls return items that are currently available in the store at the time of the request. To retrieve items that are not yet available or are no longer available, include the parameter
"show_inactive_time_limited_items": 1 in the catalog request.
You can sell items using the following methods:
- Fast purchase — sell one SKU multiple times.
- Cart purchase — the user adds items to the cart, removes items, and updates quantities within a single order.
If an item is purchased using virtual currency instead of real money, use the Create order with specified item purchased by virtual currency API call. The payment UI is not required, as the charge is processed when the API call is executed.
For free item purchase, use the Create order with specified free item API call or the Create order with free cart API call. The payment UI is not required — the order is immediately set to the done status.
Use the client-side API call to create an order with a specified item. The call returns a token used to open the payment UI.
Discount information is available to the user only in the payment UI. Promo codes are not supported.
Cart setup and purchase can be performed on the client or on the server side.
Set up and purchase a cart on the client
Implement the logic of adding and removing items by yourself. Before calling the API for setting up a cart, you will not have information about which promotions will be applied to the purchase. This means that the total cost and details of the added bonus items will not be known.
Implement the following cart logic:
- After the player has filled a cart, use the Fill cart with items API call. The call returns the current information about the selected items (prices before and after discounts, bonus items).
- Update the cart contents based on user actions:
- To add an item or change item quantity, use the Update cart item by cart ID API call.
- To remove an item, use the Delete cart item by cart ID API call.
To get the current status of the cart, use the Get current user's cart API call.
- Use the Create order with all items from current cart API call. The call returns the order ID and payment token. The newly created order is set to
newstatus by default.
Set up and purchase a cart on the server
This setup option may take longer for setting the cart up, since each change to the cart must be accompanied by API calls.
Implement the following cart logic:
- After the player has filled a cart, use the Fill cart with items API call. The call returns current information about the selected items (prices before and after discounts, bonus items).
- Use the Create order with all items from current cart API call. The call returns the order ID and payment token. The newly created order is set to
newstatus by default.
Use the returned token to open the payment UI in a new window. Other ways to open the payment UI are described in the documentation.
| Action | Endpoint |
|---|---|
| Open in production environment. | https://secure.xsolla.com/paystation4/?token={token} |
| Open in sandbox mode. | https://sandbox-secure.xsolla.com/paystation4/?token={token} |
Use sandbox mode during development and testing. Test purchases don't charge real accounts. You can use test bank cards.
After the first real payment is made, a strict sandbox payment policy takes effect. A payment in sandbox mode is available only to users specified in Publisher Account > Company settings > Users.
Buying virtual currency and items for real currency is possible only after signing a license agreement with Xsolla. To do this, in Publisher Account, go to Agreements & Taxes > Agreements, complete the agreement form, and wait for confirmation. It may take up to 3 business days to review the agreement.
To enable or disable sandbox mode, change the value of the sandbox parameter in the request for fast purchase and cart purchase. Sandbox mode is off by default.
Possible order statuses:
new— order createdpaid— payment receiveddone— item deliveredcanceled— order canceledexpired— payment expired
Track order status using one of the following methods:
API calls that return large sets of records (for example, when building a catalog) return data in pages. Pagination is a mechanism that limits the number of items returned in a single API response and allows you to retrieve subsequent pages sequentially.
Use the following parameters to control the number of returned items:
limit— number of items per pageoffset— index of the first item on the page (numbering starts from 0)has_more— indicates whether another page is availabletotal_items_count— total number of items
Example request:
GET /items?limit=20&offset=40Response example:
{
"items": [...],
"has_more": true,
"total_items_count": 135
}It is recommended to send subsequent requests until the response returns has_more = false.
Dates and time values are passed in the ISO 8601 format.
The following are supported:
- UTC offset
nullvalue when there is no time restriction for displaying an item- Unix timestamp (in seconds) used in some fields
Format: YYYY-MM-DDTHH:MM:SS±HH:MM
Example: 2026-03-16T10:00:00+03:00
Xsolla supports localization of user-facing fields such as item name and description. Localized values are passed as an object where the language code is used as the key. The full list of supported languages is available in the documentation.
Supported fields
Localization can be specified for the following parameters:
namedescriptionlong_description
Locale format
The locale key can be specified in one of the following formats:
- Two-letter language code:
en,ru - Five-letter language code:
en-US,ru-RU,de-DE
Examples
Example with a two-letter language code:
{
"name": {
"en": "Starter Pack",
"ru": "Стартовый набор"
}
}Example with a five-letter language code:
{
"description": {
"en-US": "Premium bundle",
"de-DE": "Premium-Paket"
}
}If an error occurs, the API returns an HTTP status and a JSON response body. The full list of store-related errors is available in the documentation.
Response example:
{
"errorCode": 1102,
"errorMessage": "Validation error",
"statusCode": 422,
"transactionId": "c9e1a..."
}errorCode— error code.errorMessage— short error description.statusCode— HTTP response status.transactionId— request ID. Returned only in some cases.errorMessageExtended— additional error details, such as request parameters. Returned only in some cases.
Extended response example:
{
"errorCode": 7001,
"errorMessage": "Chain not found",
"errorMessageExtended": {
"chain_id": "test_chain_id",
"project_id": "test_project_id",
"step_number": 2
},
"statusCode": 404
}Common HTTP status codes
400— invalid request401— authentication error403— insufficient permissions404— resource not found422— validation error429— rate limit exceeded
Recommendations
- Handle the HTTP status and the response body together.
- Use
errorCodeto process errors related to application logic. - Use
transactionIdto identify requests more quickly when analyzing errors.
요청
주문 및 주문에 대한 지불 토큰을 생성합니다. 주문은 요청 본문에 전달된 아이템에 기반하여 생성됩니다.
새 창에서 결제 UI를 열려면 https://secure.xsolla.com/paystation4/?token={token} 링크를 사용하십시오. 여기에서 {token}은 받은 토큰입니다.
테스트 목적으로 https://sandbox-secure.xsolla.com/paystation4/?token={token} URL을 사용합니다.
user.country.value 매개 변수는 주문에 대한 통화를 선택하는 데 사용됩니다. 사용자의 국가를 알 수 없는 경우, 대신
X-User-Ip 헤더의 사용자 IP를 제공할 수 있습니다. 이 메서드가 적절히 작동하기 위해서는 두 가지 옵션 중 하나가 필요합니다.
선택한 통화는 페이 스테이션의 결제 방식에 사용됩니다.
Project ID. You can find this parameter in your Publisher Account next to the project name and in the browser address bar when working with a project. The URL has the following format: https://publisher.xsolla.com/<merchant_id>/projects/<project_id>.
사용자 지정 매개 변수는 키-값 쌍의 유효한 JSON 집합으로 표시됩니다.
이 필드를 통해 추가 매개 변수를 전달하여 부정 결제 방지 필터를 구성할 수 있습니다. 페이 스테이션 설명서를 참조해주세요.
고유한 대/소문자 구분 코드입니다. 문자와 숫자를 포함합니다.
결제 프로세스를 테스트하기 위해 true 값으로 설정합니다. 이 경우 테스트 결제 UI에 액세스하기 위해 https://sandbox-secure.Xsolla.com을 사용합니다.
사용자의 결제 프로세스와 결제 UI를 구성하는 설정입니다.
선호하는 결제 통화입니다. ISO 4217에 따른 3자리 통화 코드입니다. 엑솔라에서 지원하는 통화에 대한 자세한 정보는 설명서에서 확인하십시오.
인터페이스 언어입니다. 2자리 소문자 언어 코드입니다.
결제 수단 ID입니다. 일부 결제 방법은 특정 통화만 지원할 수 있으므로 결제 인터페이스에서 통화 표시를 결정합니다.
사용자를 반환 URL로 리디렉션하도록 트리거하는 결제 상태입니다.
결제 후 사용자를 리디렉션하는 페이지입니다. 매개 변수 user_id, foreigninvoice, invoice_id, status가 자동으로 링크에 추가됩니다.
인터페이스 설정입니다.
결제 UI에 3자리 ISO 4217 통화 코드를 표시하려면 code로 설정하십시오. 기본적으로는 3자리 통화 코드 대신 통화 기호가 표시됩니다.
데스크톱 버전용 인터페이스 설정입니다.
헤더 설정입니다.
데스크톱 결제 UI에 닫기 버튼을 표시할지 여부입니다. 이 버튼은 결제 UI를 닫고 사용자를 settings.return_url 매개 변수에 지정된 URL로 리디렉션합니다. 기본적으로 false로 설정되어 있습니다.
헤더를 표시하는 방식입니다. compact(프로젝트 이름 및 사용자 ID 표시 안 함) 또는 normal(기본값)일 수 있습니다.
true인 경우, 헤더에 로고가 표시됩니다. 이미지를 업로드하려면 관리자 페이지에서 프로젝트를 열고 페이 스테이션 > 설정 섹션으로 이동하십시오.
모바일 버전으로 결제 UI를 열 때 장바구니에 있는 아이템 목록을 표시할지 여부입니다. true이면 목록이 확장된 보기로 표시됩니다. false(기본값)이거나 매개 변수가 전달되지 않으면 목록이 축소된 보기로 표시됩니다.
삽입된 런처의 브라우저(WebView)에서 기본 브라우저로 사용자를 리디렉션하여 구매할지 여부입니다.
결제 UI를 열 때 사용자의 국가에서 사용할 수 있는 결제 방식 목록이 표시되는지 여부입니다. false(기본값)인 경우 settings.payment_method 매개 변수에서 전달된 결제 방식이나 PayRank 알고리즘으로 선택한 결제 방식이 표시됩니다.
외부 자원에 대한 링크를 리디렉션할지 여부입니다. 외부 링크를 클릭하면 postMessage 메커니즘을 통해 external-link-open 이벤트가 전송됩니다. 리디렉션된 링크 주소는 url 매개 변수에 전달됩니다 .
결제 페이지를 닫기 전에 × 아이콘 위로 마우스를 가져갔을 때 거래 처리에 대한 경고를 표시할지 여부입니다. false가 전달되거나 매개 변수가 전달되지 않으면 경고가 표시되지 않습니다.
3-D 보안 확인이 새 브라우저 창에서 열릴지 여부입니다. 설정에서 CSP(콘텐츠 보안 정책)를 적용하는 경우로 true설정합니다.
결제 UI의 주요 요소 위치. 게임 내부에서 결제 UI를 열거나 주문 및 결제 방식에 대한 정보로 열을 바꿀 수 있습니다. 자세한 정보는 사용자 정의 지침을 참조해 주세요.
결제 UI의 인터페이스 모드. user_account만 가능합니다. 헤더에는 계정 탐색 메뉴만 포함되며 사용자는 제품을 선택하거나 결제할 수 없습니다. 이 모드는 데스크톱에서만 사용할 수 있습니다.
결제 UI 테마. 라이트 테마(기본값)의 경우 63295a9a2e47fab76f7708e1, 다크 테마의 경우 63295aab2e47fab76f7708e3일 수 있습니다. 사용자 정의 테마를 생성하고 이 매개 변수의 해당 ID를 전달할 수도 있습니다.
사용자 계정 세부 정보입니다.
내 계정 페이지입니다.
내 결제 계정의 하위 메뉴입니다.
ISO 3166-1 alpha-2에 따른 2자리 대문자 국가 코드입니다. X-User-Ip 헤더에서 IP 주소가 전달되지 않을 경우 필요합니다. 엑솔라에서 지원하는 국가에 대한 자세한 정보는 설명서를 확인하십시오.
예: country=US
사용자 ID입니다. 테스트 목적으로 어떤 값이나 전달할 수 있습니다. 실제 결제를 수락하려면 시스템의 사용자 ID 값을 사용해야 합니다. 이 ID는 유효성 검사 웹훅에서 전달됩니다.
법인 세부 정보가 있는 개체입니다. user.is_legal이 true인 경우 개체와 이에 해당하는 모든 매개 변수는 필수입니다.
기업이 속한 국가입니다. ISO 3166-1 alpha-2에 따른 2자로 된 대문자 국가 코드를 사용합니다.
- https://store.xsolla.com/api/v3/project/{project_id}/admin/payment/token
- Mock serverhttps://xsolla.redocly.app/_mock/ko/api/catalog/v3/project/{project_id}/admin/payment/token
- curl
- JavaScript
- Node.js
- Python
- Java
- C#
- PHP
- Go
- Ruby
- R
- Payload
curl -i -X POST \
-u <username>:<password> \
https://store.xsolla.com/api/v3/project/44056/admin/payment/token \
-H 'Content-Type: application/json' \
-d '{
"purchase": {
"items": [
{
"quantity": 2,
"sku": "com.xsolla.cup01"
},
{
"quantity": 1,
"sku": "com.xsolla.t-shirt01"
},
{
"quantity": 1,
"sku": "com.xsolla.cup02"
},
{
"quantity": 1,
"sku": "com.xsolla.hat01"
}
]
},
"settings": {
"currency": "USD",
"external_id": "AABBCCDD01",
"language": "de",
"payment_method": 1380,
"return_url": "https://developers.xsolla.com/ko/",
"ui": {
"theme": "63295aab2e47fab76f7708e3"
}
},
"user": {
"country": {
"allow_modify": false,
"value": "US"
},
"email": {
"value": "user@xsolla.com"
},
"id": {
"value": "user-id"
},
"name": {
"value": "user-name"
}
}
}'{ "order_id": 12345, "token": "huooAqbXBSJxB8Q4dYBqJp4ybiInqsPb" }